﻿package 
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	

	public class Zoomer extends Sprite
	{
		private var drawer:Sprite;
		private var data:BitmapData;
		private var background:Bitmap;
		private var cloned:BitmapData;
		private var upground:Bitmap;
		private var counter:Number = 1;
		public function Zoomer()
		{
				addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			setup();
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			stage.addEventListener(MouseEvent.MOUSE_DOWN,down_handler);
			stage.addEventListener(MouseEvent.MOUSE_UP,up_handler);
		}
		private function fullhandler(e:FullScreenEvent):void
		{
			while(numChildren>0){
				this.removeChildAt(0);
			}
			data = null;
			
		}
		
		private function setup():void
		{
			data = new BitmapData(stage.stageWidth,stage.stageHeight,true,0x000000);
			background = new Bitmap(data);
			addChild(background);
		}
		
		private function down_handler(e:MouseEvent):void
		{
			addEventListener(Event.ENTER_FRAME, enterHandler);
		}
		private function up_handler(e:MouseEvent):void
		{
			removeEventListener(Event.ENTER_FRAME,enterHandler);
			setup();
		}
		
		private function enterHandler(e:Event):void
		{
			if(data == null){
				setup();
			}
			if(counter>300){
				counter = 100;
			}else{
				counter++;
			}
			var my_drawer:Sprite = buildDrawer();
			var support:Sprite = new Sprite();
			my_drawer.x = stage.stageWidth/1.5-100;
			my_drawer.y = stage.stageHeight/1.5-100;
			my_drawer.scaleX=my_drawer.scaleY=1;
			support.addChild(my_drawer);
			data.draw(support);
			cloned = data.clone();
			var mul:uint = 0x100;
			data.merge(cloned,new Rectangle(0,0,stage.stageWidth,stage.stageHeight),new Point(counter,counter-40),mul,mul,mul,mul);
			
		}
		private function buildDrawer():Sprite
		{
			drawer = new Sprite();
			drawer.graphics.beginFill(0x0098ff,.05);
			drawer.graphics.lineStyle(3,0xffffff,100);
			drawer.graphics.drawRect(-stage.stageWidth/2,-stage.stageHeight/2,50,stage.stageHeight);
			drawer.graphics.drawRect(-stage.stageWidth/2,-stage.stageHeight/2+50,stage.stageWidth,50);
			
			drawer.graphics.beginFill(0xffffff,.4);
			drawer.graphics.lineStyle(2,0x000000,800);
			drawer.graphics.drawRect(stage.stageWidth/-2,-stage.stageHeight*2.422,50,stage.stageHeight*2);
			
			drawer.graphics.beginFill(0xffffff,.05);
			drawer.graphics.lineStyle(2,0x000000,1);
			drawer.graphics.drawRect(-stage.stageWidth/2,stage.stageHeight/2-500,stage.stageWidth,50);
			drawer.graphics.endFill();
			//drawer.rotation = Math.random()*0;
			return drawer;
		}
		
	}
}